import { __decorate } from '../../external/tslib/tslib.es6.js';
import { Global, Module } from '@nestjs/common';
import { PARAMETER_STORE_CONFIG_PARAMETERS, PARAMETER_STORE_CONFIG_PROPERTIES } from '../../shared/constant/config/constant.js';
import { ParameterStoreConfigParametersProvider } from '../../shared/provider/config/config-parameters.provider.js';
import { ParameterStoreConfigPropertiesProvider } from '../../shared/provider/config/properties.provider.js';
import { ParameterStoreConfigSSMProvider } from '../../shared/provider/config/ssm-client.provider.js';
import { ParameterStoreService } from '../aws/parameter-store/parameter-store.service.js';
import { ParameterStoreConfigService } from './config.service.js';

var ParameterStoreConfigModule_1;
let ParameterStoreConfigModule = ParameterStoreConfigModule_1 = class ParameterStoreConfigModule {
    static register(options) {
        const propertiesProvider = ParameterStoreConfigPropertiesProvider(options);
        return {
            exports: [ParameterStoreConfigService, PARAMETER_STORE_CONFIG_PARAMETERS],
            module: ParameterStoreConfigModule_1,
            providers: [propertiesProvider, ParameterStoreConfigParametersProvider, ParameterStoreConfigSSMProvider, ParameterStoreConfigService, ParameterStoreService],
        };
    }
    static registerAsync(properties) {
        const providers = this.createAsyncProviders(properties);
        return {
            exports: [ParameterStoreConfigService, PARAMETER_STORE_CONFIG_PARAMETERS],
            imports: properties.imports ?? [],
            module: ParameterStoreConfigModule_1,
            providers,
        };
    }
    static createAsyncOptionsProvider(properties) {
        if (properties.useFactory) {
            return {
                inject: properties.inject ?? [],
                provide: PARAMETER_STORE_CONFIG_PROPERTIES,
                useFactory: properties.useFactory,
            };
        }
        const inject = properties.useExisting ?? properties.useClass;
        return {
            inject: inject ? [inject] : [],
            provide: PARAMETER_STORE_CONFIG_PROPERTIES,
            useFactory: async (optionsFactory) => {
                return optionsFactory.createOptions();
            },
        };
    }
    static createAsyncProviders(properties) {
        const optionsProvider = this.createAsyncOptionsProvider(properties);
        const requestProviders = [optionsProvider, ParameterStoreConfigParametersProvider, ParameterStoreConfigSSMProvider, ParameterStoreConfigService, ParameterStoreService];
        if (properties.useExisting || properties.useFactory || !properties.useClass) {
            return requestProviders;
        }
        return [
            ...requestProviders,
            {
                provide: properties.useClass,
                useClass: properties.useClass,
            },
        ];
    }
};
ParameterStoreConfigModule = ParameterStoreConfigModule_1 = __decorate([
    Global(),
    Module({})
], ParameterStoreConfigModule);

export { ParameterStoreConfigModule };
//# sourceMappingURL=config.module.js.map
